
/*  A Bison parser, made from parse.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define	CLASS	257
#define	FROM	258
#define	CONST	259
#define	VOID	260
#define	STRUCT	261
#define	UNION	262
#define	ENUM	263
#define	THREEDOTS	264
#define	SIGNED	265
#define	UNSIGNED	266
#define	LONG	267
#define	SHORT	268
#define	INT	269
#define	FLOAT	270
#define	DOUBLE	271
#define	CHAR	272
#define	ONERROR	273
#define	TOKEN	274
#define	NUMBER	275
#define	TYPETOKEN	276
#define	ARRAY_DIM	277
#define	CCODE	278
#define	HTCODE	279
#define	PHCODE	280
#define	HCODE	281
#define	ACODE	282
#define	ATCODE	283
#define	PUBLIC	284
#define	PRIVATE	285
#define	PROTECTED	286
#define	ARGUMENT	287
#define	VIRTUAL	288
#define	SIGNAL	289
#define	OVERRIDE	290

#line 21 "parse.y"


#include "config.h"
#include <glib.h>
#include <stdio.h>
#include <string.h>

#include "tree.h"
#include "main.h"
#include "util.h"

#define _(x) (x)
	
GList *nodes = NULL;

static GList *class_nodes = NULL;
Node *class = NULL;

static GList *typestack = NULL;
static int stars = 0;
static GList *funcargs = NULL;
static GList *checks = NULL;
static int has_self = FALSE;
static int vararg = FALSE;

static GList *gtktypes = NULL;

/* this can be a global as we will only do one function at a time
   anyway */
static int the_scope = NO_SCOPE;

void free(void *ptr);
int yylex(void);

extern int ccode_line;
extern int line_no;

extern char *yytext;

static void
yyerror(char *str)
{
	char *out=NULL;
	char *p;
	
	if(strcmp(yytext,"\n")==0) {
		out=g_strconcat("Error: ",str," before newline",NULL);
	} else if(yytext[0]=='\0') {
		out=g_strconcat("Error: ",str," at end of input",NULL);
	} else {
		char *tmp = g_strdup(yytext);
		while((p=strchr(tmp,'\n')))
			*p='.';

		out=g_strconcat("Error: ",str," before '",tmp,"'",NULL);
		g_free(tmp);
	}

	fprintf(stderr,"%s:%d: %s\n",filename,line_no,out);
	g_free(out);
	
	exit(1);
}

static Type *
pop_type(void)
{
	Type *type = typestack->data;
	typestack = g_list_remove(typestack,typestack->data);
	return type;
}

static void
push_variable(char *name, int scope, int line_no, char *postfix)
{
	Node *var;
	Type *type = pop_type();

	type->postfix = postfix;
	
	var = new_variable(scope,type,name,line_no);
	class_nodes = g_list_append(class_nodes, var);
}

static void
push_function(int scope, int method, char *oid, char *id, char *onerror,
	      GString *cbuf, int line_no, int ccode_line, gboolean vararg,
	      GList *flags)
{
	Node *node;
	Type *type;
	char *c_cbuf;
       
	if(method!=INIT_METHOD && method!=CLASS_INIT_METHOD) {
		type = pop_type();
	} else {
		type = (Type *)new_type(0,g_strdup("void"),NULL);
	}
	
	/* a complicated and ugly test to figure out if we have
	   the wrong number of types for a signal */
	if((method == SIGNAL_FIRST_METHOD ||
	    method == SIGNAL_LAST_METHOD) &&
	   g_list_length(gtktypes) != g_list_length(funcargs) &&
	   !(g_list_length(funcargs) == 1 &&
	     g_list_length(gtktypes) == 2 &&
	     strcmp(gtktypes->next->data,"NONE")==0)) {
		print_error(TRUE, _("The number of GTK arguments and "
				    "function arguments for a signal "
				    "don't seem to match"),line_no);
	}
	if(cbuf) {
		char *p;
		c_cbuf = p = cbuf->str;
		while(p && *p && (*p==' ' || *p=='\t' || *p=='\n' || *p=='\r'))
			p++;
		if(!p || !*p)
			c_cbuf = NULL;
	} else
		c_cbuf = NULL;

	node = new_method(scope, method, type, oid, gtktypes, flags,
			  id, funcargs, onerror, c_cbuf, line_no,
			  ccode_line, vararg);

	if(cbuf)
		g_string_free(cbuf,
			      /*only free segment if we haven't passed it
				above */
			      c_cbuf?FALSE:TRUE);
	gtktypes = NULL;
	funcargs = NULL;

	class_nodes = g_list_append(class_nodes, node);
}

static void
push_funcarg(char *name, char *postfix)
{
	Node *node;
	Type *type = pop_type();

	type->postfix = postfix;
	
	node = new_funcarg(type,name,checks);
	checks = NULL;
	
	funcargs = g_list_append(funcargs, node);
}

static void
push_init_arg(char *name, int is_class)
{
	Node *node;
	Node *type;
	char *tn;
	
	if(is_class)
		tn = g_strconcat(((Class *)class)->otype,":Class",NULL);
	else
		tn = g_strdup(((Class *)class)->otype);

	type = new_type(1,tn,NULL);
	node = new_funcarg((Type *)type,name,NULL);
	funcargs = g_list_prepend(funcargs, node);
}

static void
push_self(char *id)
{
	Node *node;
	Node *type;
	GList *ch = NULL;
	type = new_type(1,g_strdup(((Class *)class)->otype),NULL);
	ch = g_list_append(ch,new_check(NULL_CHECK,NULL));
	ch = g_list_append(ch,new_check(TYPE_CHECK,NULL));
	node = new_funcarg((Type *)type,id,ch);
	funcargs = g_list_prepend(funcargs, node);
}


#line 203 "parse.y"
typedef union {
	char *id;
	GString *cbuf;
	GList *list;
	int line;
	int sigtype;
} YYSTYPE;
#ifndef YYDEBUG
#define YYDEBUG 1
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		225
#define	YYFLAG		-32768
#define	YYNTBASE	50

#define YYTRANSLATE(x) ((unsigned)(x) <= 290 ? yytranslate[x] : 82)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    48,     2,     2,     2,     2,     2,     2,    40,
    41,    43,     2,    44,    49,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,    39,    46,
    47,    45,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    37,    42,    38,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32,    33,    34,    35,    36
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     4,     7,    10,    12,    14,    16,    18,    20,    22,
    24,    27,    29,    34,    38,    43,    46,    49,    52,    54,
    56,    58,    60,    62,    64,    69,    75,    87,    96,   102,
   104,   108,   109,   113,   115,   117,   120,   122,   125,   128,
   131,   133,   136,   139,   141,   143,   145,   147,   150,   152,
   154,   157,   159,   162,   164,   166,   168,   170,   172,   175,
   177,   180,   182,   186,   190,   193,   195,   200,   204,   206,
   209,   211,   222,   234,   244,   254,   263,   275,   284,   290,
   293,   297,   298,   300,   302,   306,   308,   312,   314,   318,
   320,   323,   327,   334,   342,   345,   347,   349,   352,   355,
   359,   363,   367,   371,   373,   376
};

static const short yyrhs[] = {    52,
    53,    52,     0,    53,    52,     0,    52,    53,     0,    53,
     0,    24,     0,    27,     0,    25,     0,    26,     0,    28,
     0,    29,     0,    52,    51,     0,    51,     0,    54,    37,
    55,    38,     0,    54,    37,    38,     0,     3,    22,     4,
    22,     0,    55,    73,     0,    55,    57,     0,    55,    58,
     0,    73,     0,    57,     0,    58,     0,    30,     0,    31,
     0,    32,     0,    56,    62,    20,    39,     0,    56,    62,
    20,    23,    39,     0,    33,    60,    59,    20,    20,    37,
    24,    20,    37,    24,    39,     0,    33,    60,    59,    20,
    20,    37,    24,    39,     0,    20,    40,    20,    62,    41,
     0,    20,     0,    40,    61,    41,     0,     0,    20,    42,
    61,     0,    20,     0,    63,     0,     5,    63,     0,    64,
     0,    64,    67,     0,    12,    65,     0,    11,    65,     0,
    65,     0,    12,    18,     0,    11,    18,     0,    18,     0,
    17,     0,    16,     0,    20,     0,    66,    20,     0,    22,
     0,     6,     0,    13,    15,     0,    13,     0,    14,    15,
     0,    14,     0,    15,     0,     9,     0,     8,     0,     7,
     0,    43,    67,     0,    43,     0,    20,    70,     0,    70,
     0,    56,    20,    70,     0,    20,    56,    70,     0,    56,
    70,     0,    68,     0,    20,    40,    71,    41,     0,    71,
    44,    20,     0,    20,     0,    37,    24,     0,    39,     0,
    35,    60,    69,    62,    20,    40,    75,    41,    74,    72,
     0,    56,    35,    60,    68,    62,    20,    40,    75,    41,
    74,    72,     0,    34,    56,    62,    20,    40,    75,    41,
    74,    72,     0,    56,    34,    62,    20,    40,    75,    41,
    74,    72,     0,    34,    62,    20,    40,    75,    41,    74,
    72,     0,    36,    40,    22,    41,    62,    20,    40,    75,
    41,    74,    72,     0,    56,    62,    20,    40,    75,    41,
    74,    72,     0,    20,    40,    20,    41,    72,     0,    19,
    81,     0,    19,    37,    24,     0,     0,     6,     0,    20,
     0,    20,    44,    76,     0,    76,     0,    77,    44,    10,
     0,    77,     0,    77,    44,    78,     0,    78,     0,    62,
    20,     0,    62,    20,    23,     0,    62,    20,    40,    20,
    79,    41,     0,    62,    20,    23,    40,    20,    79,    41,
     0,    79,    80,     0,    80,     0,    20,     0,    45,    81,
     0,    46,    81,     0,    45,    47,    81,     0,    46,    47,
    81,     0,    47,    47,    81,     0,    48,    47,    81,     0,
    21,     0,    49,    21,     0,    20,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   222,   223,   224,   225,   228,   234,   240,   246,   252,   258,
   266,   267,   270,   275,   282,   287,   288,   289,   290,   291,
   292,   295,   296,   297,   300,   303,   307,   342,   372,   381,
   387,   388,   391,   394,   400,   401,   409,   413,   420,   423,
   426,   429,   432,   435,   438,   441,   444,   447,   451,   454,
   459,   462,   465,   468,   471,   476,   479,   482,   487,   488,
   492,   504,   510,   522,   534,   537,   543,   548,   551,   556,
   557,   561,   571,   581,   591,   601,   611,   617,   622,   643,
   644,   648,   651,   652,   663,   673,   676,   677,   680,   681,
   684,   687,   690,   698,   708,   709,   712,   725,   729,   733,
   737,   741,   745,   751,   752,   756
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","CLASS",
"FROM","CONST","VOID","STRUCT","UNION","ENUM","THREEDOTS","SIGNED","UNSIGNED",
"LONG","SHORT","INT","FLOAT","DOUBLE","CHAR","ONERROR","TOKEN","NUMBER","TYPETOKEN",
"ARRAY_DIM","CCODE","HTCODE","PHCODE","HCODE","ACODE","ATCODE","PUBLIC","PRIVATE",
"PROTECTED","ARGUMENT","VIRTUAL","SIGNAL","OVERRIDE","'{'","'}'","';'","'('",
"')'","'|'","'*'","','","'>'","'<'","'='","'!'","'-'","prog","ccode","ccodes",
"class","classdec","classcode","scope","variable","argument","argtype","flags",
"flaglist","type","type1","type2","integer","tspecifier","stars","simplesigtype",
"fullsigtype","sigtype","tokenlist","codenocode","method","onerror","funcargs",
"arglist","arglist1","arg","checklist","check","numtok", NULL
};
#endif

static const short yyr1[] = {     0,
    50,    50,    50,    50,    51,    51,    51,    51,    51,    51,
    52,    52,    53,    53,    54,    55,    55,    55,    55,    55,
    55,    56,    56,    56,    57,    57,    58,    58,    59,    59,
    60,    60,    61,    61,    62,    62,    63,    63,    64,    64,
    64,    64,    64,    64,    64,    64,    64,    64,    64,    64,
    65,    65,    65,    65,    65,    66,    66,    66,    67,    67,
    68,    68,    69,    69,    69,    69,    70,    71,    71,    72,
    72,    73,    73,    73,    73,    73,    73,    73,    73,    74,
    74,    74,    75,    75,    75,    75,    76,    76,    77,    77,
    78,    78,    78,    78,    79,    79,    80,    80,    80,    80,
    80,    80,    80,    81,    81,    81
};

static const short yyr2[] = {     0,
     3,     2,     2,     1,     1,     1,     1,     1,     1,     1,
     2,     1,     4,     3,     4,     2,     2,     2,     1,     1,
     1,     1,     1,     1,     4,     5,    11,     8,     5,     1,
     3,     0,     3,     1,     1,     2,     1,     2,     2,     2,
     1,     2,     2,     1,     1,     1,     1,     2,     1,     1,
     2,     1,     2,     1,     1,     1,     1,     1,     2,     1,
     2,     1,     3,     3,     2,     1,     4,     3,     1,     2,
     1,    10,    11,     9,     9,     8,    11,     8,     5,     2,
     3,     0,     1,     1,     3,     1,     3,     1,     3,     1,
     2,     3,     6,     7,     2,     1,     1,     2,     2,     3,
     3,     3,     3,     1,     2,     1
};

static const short yydefact[] = {     0,
     0,     5,     7,     8,     6,     9,    10,    12,     0,     4,
     0,     0,    11,     3,     2,     0,     0,     1,     0,    22,
    23,    24,    32,     0,    32,     0,    14,     0,     0,    20,
    21,    19,    15,     0,     0,     0,     0,    50,    58,    57,
    56,     0,     0,    52,    54,    55,    46,    45,    44,    47,
    49,     0,     0,    35,    37,    41,     0,     0,     0,    13,
    17,    18,    16,     0,    32,     0,     0,    34,     0,    30,
     0,    36,    43,    40,    42,    39,    51,    53,     0,     0,
    60,    38,    48,     0,     0,    66,     0,    62,     0,     0,
     0,     0,     0,     0,    31,     0,     0,     0,     0,    59,
     0,     0,     0,    61,     0,    65,     0,     0,     0,     0,
     0,     0,    25,     0,     0,    71,    79,    33,     0,     0,
     0,    50,    47,     0,     0,    86,    88,    90,    69,     0,
    64,    63,     0,     0,     0,     0,    26,     0,    70,     0,
     0,     0,     0,    91,    82,     0,    67,     0,     0,     0,
     0,     0,    82,    29,     0,    82,    85,    92,     0,     0,
     0,    87,    89,    68,     0,     0,    82,     0,     0,     0,
    28,     0,     0,     0,   106,   104,     0,     0,    80,    76,
    82,     0,     0,     0,    78,     0,    74,     0,    97,     0,
     0,     0,     0,     0,    96,    81,   105,     0,    82,    75,
    82,     0,     0,     0,    98,     0,    99,     0,     0,    93,
    95,    72,     0,     0,    27,    94,   100,   101,   102,   103,
    77,    73,     0,     0,     0
};

static const short yydefgoto[] = {   223,
     8,     9,    10,    11,    28,    29,    30,    31,    71,    36,
    69,   124,    54,    55,    56,    57,    82,    86,    87,    88,
   130,   117,    32,   161,   125,   126,   127,   128,   194,   195,
   179
};

static const short yypact[] = {   136,
     4,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   136,   119,
    32,    10,-32768,   119,   119,   146,    67,   119,    40,-32768,
-32768,-32768,    57,   120,    57,    68,-32768,   155,    59,-32768,
-32768,-32768,-32768,    78,    95,    96,   242,-32768,-32768,-32768,
-32768,   252,   258,   115,   126,-32768,-32768,-32768,-32768,-32768,
-32768,   207,   129,-32768,   113,-32768,   137,    70,   151,-32768,
-32768,-32768,-32768,   207,    57,   138,   133,   141,   167,   152,
   190,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   197,   186,
   113,-32768,-32768,     2,   208,-32768,   207,-32768,   194,   224,
   226,   -19,   131,    95,-32768,   232,   241,   223,   225,-32768,
   228,   249,   254,-32768,    -4,-32768,   255,   207,   237,    -4,
   207,   239,-32768,   225,   256,-32768,-32768,-32768,   207,   244,
   225,   238,    47,   262,   243,-32768,   245,-32768,-32768,    66,
-32768,-32768,   246,   263,   225,   265,-32768,   247,-32768,   250,
   266,   251,   207,     7,   268,   189,-32768,   273,   225,   257,
   253,   259,   268,-32768,    -1,   268,-32768,   260,   275,   -10,
   131,-32768,-32768,-32768,   261,   225,   268,   225,   131,   264,
-32768,   131,   276,    76,-32768,-32768,   274,   282,-32768,-32768,
   268,   267,   131,   269,-32768,   280,-32768,    76,-32768,    62,
    65,   270,   271,    58,-32768,-32768,-32768,   131,   268,-32768,
   268,   272,    72,    -8,-32768,    -8,-32768,    -8,    -8,-32768,
-32768,-32768,   131,   131,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,   305,   306,-32768
};

static const short yypgoto[] = {-32768,
    37,   145,   298,-32768,-32768,   -23,   281,   284,-32768,   -17,
   219,   -24,   277,-32768,    15,-32768,   234,   229,-32768,   -60,
-32768,  -154,   288,  -150,  -112,   176,-32768,   175,   134,  -141,
   -37
};


#define	YYLAST		322


static const short yytable[] = {    53,
    52,   138,   169,   112,    66,   172,   180,    58,   142,   175,
   176,   175,   176,    17,   185,   101,   183,   187,   170,   113,
   114,   101,   151,   104,   106,    12,   177,    79,   200,   158,
   198,    20,    21,    22,    85,   102,   165,   171,   178,    90,
   178,   102,   131,   212,   132,    13,   159,    91,   213,   104,
   214,    13,   211,   182,    13,   184,    74,    76,   221,   222,
   103,   211,   107,    37,    38,    39,    40,    41,    16,    42,
    43,    44,    45,    46,    47,    48,    49,   189,    50,    34,
    51,   175,   176,   134,   175,   176,   136,   -84,    33,    84,
   143,   189,    64,    65,   140,   189,    35,    67,   210,    20,
    21,    22,   190,   191,   192,   193,   147,    59,   204,   148,
   178,   206,   216,   178,    68,    70,   190,   191,   192,   193,
   190,   191,   192,   193,    37,    38,    39,    40,    41,    77,
    42,    43,    44,    45,    46,    47,    48,    49,     1,    50,
    78,    51,     2,     3,     4,     5,     6,     7,    80,    20,
    21,    22,   205,   207,    15,    81,    83,    92,    18,     2,
     3,     4,     5,     6,     7,    19,   217,   115,   218,   116,
   219,   220,    89,    93,    19,    20,    21,    22,    23,    24,
    25,    26,    94,    27,    20,    21,    22,    23,    24,    25,
    26,    96,    60,    37,    38,    39,    40,    41,   162,    42,
    43,    44,    45,    46,    47,    48,    49,    95,    50,    97,
    51,    37,    38,    39,    40,    41,    98,    42,    43,    44,
    45,    46,    47,    48,    49,    99,    50,   105,    51,    37,
   122,    39,    40,    41,   108,    42,    43,    44,    45,    46,
    47,    48,    49,   109,   123,   110,    51,    38,    39,    40,
    41,   119,    42,    43,    44,    45,    46,    47,    48,    49,
   120,    50,   121,    51,    44,    45,    46,   102,   129,    73,
    44,    45,    46,   101,   133,    75,   135,   137,   -83,   139,
   141,   144,   150,   145,   152,   149,   160,   153,   146,   155,
   154,   156,   164,   167,   174,   188,   166,   196,   168,   173,
   186,   181,   197,   202,   224,   225,    14,   199,    61,   201,
   215,    62,   118,    72,   100,    63,   208,   209,   157,   111,
   163,   203
};

static const short yycheck[] = {    24,
    24,   114,   153,    23,    29,   156,   161,    25,   121,    20,
    21,    20,    21,     4,   169,    20,   167,   172,    20,    39,
    40,    20,   135,    84,    85,    22,    37,    52,   183,    23,
   181,    30,    31,    32,    58,    40,   149,    39,    49,    64,
    49,    40,   103,   198,   105,     9,    40,    65,   199,   110,
   201,    15,   194,   166,    18,   168,    42,    43,   213,   214,
    84,   203,    87,     5,     6,     7,     8,     9,    37,    11,
    12,    13,    14,    15,    16,    17,    18,    20,    20,    40,
    22,    20,    21,   108,    20,    21,   111,    41,    22,    20,
    44,    20,    34,    35,   119,    20,    40,    20,    41,    30,
    31,    32,    45,    46,    47,    48,    41,    40,    47,    44,
    49,    47,    41,    49,    20,    20,    45,    46,    47,    48,
    45,    46,    47,    48,     5,     6,     7,     8,     9,    15,
    11,    12,    13,    14,    15,    16,    17,    18,     3,    20,
    15,    22,    24,    25,    26,    27,    28,    29,    20,    30,
    31,    32,   190,   191,    10,    43,    20,    20,    14,    24,
    25,    26,    27,    28,    29,    20,   204,    37,   206,    39,
   208,   209,    22,    41,    20,    30,    31,    32,    33,    34,
    35,    36,    42,    38,    30,    31,    32,    33,    34,    35,
    36,    40,    38,     5,     6,     7,     8,     9,    10,    11,
    12,    13,    14,    15,    16,    17,    18,    41,    20,    20,
    22,     5,     6,     7,     8,     9,    20,    11,    12,    13,
    14,    15,    16,    17,    18,    40,    20,    20,    22,     5,
     6,     7,     8,     9,    41,    11,    12,    13,    14,    15,
    16,    17,    18,    20,    20,    20,    22,     6,     7,     8,
     9,    20,    11,    12,    13,    14,    15,    16,    17,    18,
    20,    20,    40,    22,    13,    14,    15,    40,    20,    18,
    13,    14,    15,    20,    20,    18,    40,    39,    41,    24,
    37,    20,    20,    41,    20,    40,    19,    41,    44,    24,
    41,    41,    20,    41,    20,    20,    40,    24,    40,    40,
    37,    41,    21,    24,     0,     0,     9,    41,    28,    41,
    39,    28,    94,    37,    81,    28,    47,    47,   143,    91,
   146,   188
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/lib/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/lib/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 222 "parse.y"
{ ; ;
    break;}
case 2:
#line 223 "parse.y"
{ ; ;
    break;}
case 3:
#line 224 "parse.y"
{ ; ;
    break;}
case 4:
#line 225 "parse.y"
{ ; ;
    break;}
case 5:
#line 228 "parse.y"
{
			Node *node = new_ccode(C_CCODE,(yyvsp[0].cbuf)->str,
					       ccode_line);
			nodes = g_list_append(nodes,node);
			g_string_free(yyvsp[0].cbuf,FALSE);
					;
    break;}
case 6:
#line 234 "parse.y"
{
			Node *node = new_ccode(H_CCODE,(yyvsp[0].cbuf)->str,
					       ccode_line);
			nodes = g_list_append(nodes,node);
			g_string_free(yyvsp[0].cbuf,FALSE);
					;
    break;}
case 7:
#line 240 "parse.y"
{
			Node *node = new_ccode(HT_CCODE,(yyvsp[0].cbuf)->str,
					       ccode_line);
			nodes = g_list_append(nodes,node);
			g_string_free(yyvsp[0].cbuf,FALSE);
					;
    break;}
case 8:
#line 246 "parse.y"
{
			Node *node = new_ccode(PH_CCODE,(yyvsp[0].cbuf)->str,
					       ccode_line);
			nodes = g_list_append(nodes,node);
			g_string_free(yyvsp[0].cbuf,FALSE);
					;
    break;}
case 9:
#line 252 "parse.y"
{
			Node *node = new_ccode(A_CCODE,(yyvsp[0].cbuf)->str,
					       ccode_line);
			nodes = g_list_append(nodes,node);
			g_string_free(yyvsp[0].cbuf,FALSE);
					;
    break;}
case 10:
#line 258 "parse.y"
{
			Node *node = new_ccode(AT_CCODE,(yyvsp[0].cbuf)->str,
					       ccode_line);
			nodes = g_list_append(nodes,node);
			g_string_free(yyvsp[0].cbuf,FALSE);
					;
    break;}
case 11:
#line 266 "parse.y"
{ ; ;
    break;}
case 12:
#line 267 "parse.y"
{ ; ;
    break;}
case 13:
#line 270 "parse.y"
{
			((Class *)class)->nodes = class_nodes;
			class_nodes = NULL;
			nodes = g_list_append(nodes,class);
						;
    break;}
case 14:
#line 275 "parse.y"
{
			((Class *)class)->nodes = NULL;
			class_nodes = NULL;
			nodes = g_list_append(nodes,class);
						;
    break;}
case 15:
#line 282 "parse.y"
{
			class = new_class(yyvsp[-2].id,yyvsp[0].id,NULL);
						;
    break;}
case 16:
#line 287 "parse.y"
{ ; ;
    break;}
case 17:
#line 288 "parse.y"
{ ; ;
    break;}
case 18:
#line 289 "parse.y"
{ ; ;
    break;}
case 19:
#line 290 "parse.y"
{ ; ;
    break;}
case 20:
#line 291 "parse.y"
{ ; ;
    break;}
case 21:
#line 292 "parse.y"
{ ; ;
    break;}
case 22:
#line 295 "parse.y"
{ the_scope = PUBLIC_SCOPE; ;
    break;}
case 23:
#line 296 "parse.y"
{ the_scope = PRIVATE_SCOPE; ;
    break;}
case 24:
#line 297 "parse.y"
{ the_scope = PROTECTED_SCOPE; ;
    break;}
case 25:
#line 300 "parse.y"
{
			push_variable(yyvsp[-1].id,the_scope,yyvsp[-3].line,NULL);
						;
    break;}
case 26:
#line 303 "parse.y"
{
			push_variable(yyvsp[-2].id,the_scope,yyvsp[-4].line,yyvsp[-1].id);
						;
    break;}
case 27:
#line 307 "parse.y"
{
			if(strcmp(yyvsp[-6].id,"get")==0 &&
			   strcmp(yyvsp[-3].id,"set")==0) {
				Node *node;
				Type *type = pop_type();
				g_free(yyvsp[-6].id); g_free(yyvsp[-3].id);
				node = new_argument(yyvsp[-8].id,type,yyvsp[-9].list,yyvsp[-7].id,
						    (yyvsp[-4].cbuf)->str,yyvsp[-5].line,
						    (yyvsp[-1].cbuf)->str,yyvsp[-2].line,
						    yyvsp[-10].line);
				g_string_free(yyvsp[-4].cbuf,FALSE);
				g_string_free(yyvsp[-1].cbuf,FALSE);
				class_nodes = g_list_append(class_nodes,node);
			} else if(strcmp(yyvsp[-6].id,"set")==0 &&
				strcmp(yyvsp[-3].id,"get")==0) {
				Node *node;
				Type *type = pop_type();
				g_free(yyvsp[-6].id); g_free(yyvsp[-3].id);
				node = new_argument(yyvsp[-8].id,type,yyvsp[-9].list,yyvsp[-7].id,
						    (yyvsp[-1].cbuf)->str,yyvsp[-2].line,
						    (yyvsp[-4].cbuf)->str,yyvsp[-5].line,
						    yyvsp[-10].line);
				g_string_free(yyvsp[-1].cbuf,FALSE);
				g_string_free(yyvsp[-4].cbuf,FALSE);
				class_nodes = g_list_append(class_nodes,node);
			} else {
				g_free(yyvsp[-8].id); g_free(yyvsp[-7].id);
				g_free(yyvsp[-6].id); g_free(yyvsp[-3].id);
				g_list_foreach(yyvsp[-9].list,(GFunc)g_free,NULL);
				g_string_free(yyvsp[-1].cbuf,TRUE);
				g_string_free(yyvsp[-4].cbuf,TRUE);
				yyerror(_("parse error"));
				YYERROR;
			}
						;
    break;}
case 28:
#line 342 "parse.y"
{
			if(strcmp(yyvsp[-3].id,"get")==0) {
				Node *node;
				Type *type = pop_type();
				g_free(yyvsp[-3].id);
				node = new_argument(yyvsp[-5].id,type,yyvsp[-6].list,yyvsp[-4].id,
						    (yyvsp[-1].cbuf)->str,yyvsp[-2].line,
						    NULL,0, yyvsp[-7].line);
				g_string_free(yyvsp[-1].cbuf,FALSE);
				class_nodes = g_list_append(class_nodes,node);
			} else if(strcmp(yyvsp[-3].id,"set")==0) {
				Node *node;
				Type *type = pop_type();
				g_free(yyvsp[-3].id);
				node = new_argument(yyvsp[-5].id,type,yyvsp[-6].list,yyvsp[-4].id,
						    NULL,0,(yyvsp[-1].cbuf)->str,
						    yyvsp[-2].line, yyvsp[-7].line);
				g_string_free(yyvsp[-1].cbuf,FALSE);
				class_nodes = g_list_append(class_nodes,node);
			} else {
				g_free(yyvsp[-3].id); g_free(yyvsp[-5].id);
				g_free(yyvsp[-4].id);
				g_list_foreach(yyvsp[-6].list,(GFunc)g_free,NULL);
				g_string_free(yyvsp[-1].cbuf,TRUE);
				yyerror(_("parse error"));
				YYERROR;
			}
						;
    break;}
case 29:
#line 372 "parse.y"
{
			if(strcmp(yyvsp[-2].id,"type")!=0) {
				g_free(yyvsp[-4].id);
				g_free(yyvsp[-2].id);
				yyerror(_("parse error"));
				YYERROR;
			}
			yyval.id = yyvsp[-4].id;
						;
    break;}
case 30:
#line 381 "parse.y"
{
			yyval.id = yyvsp[0].id;
			typestack = g_list_prepend(typestack,NULL);
						;
    break;}
case 31:
#line 387 "parse.y"
{ yyval.list = yyvsp[-1].list; ;
    break;}
case 32:
#line 388 "parse.y"
{ yyval.list = NULL; ;
    break;}
case 33:
#line 391 "parse.y"
{
			yyval.list = g_list_append(yyvsp[0].list,yyvsp[-2].id);
						;
    break;}
case 34:
#line 394 "parse.y"
{
			yyval.list = g_list_append(NULL,yyvsp[0].id);
						;
    break;}
case 35:
#line 400 "parse.y"
{ ; ;
    break;}
case 36:
#line 401 "parse.y"
{
			Type *type = typestack->data;
			char *oldname = type->name;
			type->name = g_strconcat("const ",oldname,NULL);
			g_free(oldname);
						;
    break;}
case 37:
#line 409 "parse.y"
{
			Node *node = new_type(0,yyvsp[0].id,NULL);
			typestack = g_list_prepend(typestack,node);
						;
    break;}
case 38:
#line 413 "parse.y"
{
			Node *node = new_type(stars,yyvsp[-1].id,NULL);
			stars = 0;
			typestack = g_list_prepend(typestack,node);
						;
    break;}
case 39:
#line 420 "parse.y"
{
			yyval.id = g_strconcat("unsigned ",yyvsp[0].id,NULL);
						;
    break;}
case 40:
#line 423 "parse.y"
{
			yyval.id = g_strconcat("signed ",yyvsp[0].id,NULL);
						;
    break;}
case 41:
#line 426 "parse.y"
{
			yyval.id = g_strdup(yyvsp[0].id);
						;
    break;}
case 42:
#line 429 "parse.y"
{
			yyval.id = g_strdup("unsigned char");
						;
    break;}
case 43:
#line 432 "parse.y"
{
			yyval.id = g_strdup("signed char");
						;
    break;}
case 44:
#line 435 "parse.y"
{
			yyval.id = g_strdup("char");
						;
    break;}
case 45:
#line 438 "parse.y"
{
			yyval.id = g_strdup("double");
						;
    break;}
case 46:
#line 441 "parse.y"
{
			yyval.id = g_strdup("float");
						;
    break;}
case 47:
#line 444 "parse.y"
{
			yyval.id = yyvsp[0].id;
						;
    break;}
case 48:
#line 447 "parse.y"
{
			yyval.id = g_strconcat(yyvsp[-1].id,yyvsp[0].id,NULL);
			g_free(yyvsp[0].id);
						;
    break;}
case 49:
#line 451 "parse.y"
{
			yyval.id = yyvsp[0].id;
						;
    break;}
case 50:
#line 454 "parse.y"
{
			yyval.id = g_strdup("void");
						;
    break;}
case 51:
#line 459 "parse.y"
{
			yyval.id = "long int";
						;
    break;}
case 52:
#line 462 "parse.y"
{
			yyval.id = "long";
						;
    break;}
case 53:
#line 465 "parse.y"
{
			yyval.id = "short int";
						;
    break;}
case 54:
#line 468 "parse.y"
{
			yyval.id = "short";
						;
    break;}
case 55:
#line 471 "parse.y"
{
			yyval.id = "int";
						;
    break;}
case 56:
#line 476 "parse.y"
{
			yyval.id = "enum ";
						;
    break;}
case 57:
#line 479 "parse.y"
{
			yyval.id = "union ";
						;
    break;}
case 58:
#line 482 "parse.y"
{
			yyval.id = "struct ";
						;
    break;}
case 59:
#line 487 "parse.y"
{ stars++; ;
    break;}
case 60:
#line 488 "parse.y"
{ stars++; ;
    break;}
case 61:
#line 492 "parse.y"
{
			if(strcmp(yyvsp[-1].id,"first")==0)
				yyval.sigtype = SIGNAL_FIRST_METHOD;
			else if(strcmp(yyvsp[-1].id,"last")==0)
				yyval.sigtype = SIGNAL_LAST_METHOD;
			else {
				yyerror(_("signal must be 'first' or 'last'"));
				g_free(yyvsp[-1].id);
				YYERROR;
			}
			g_free(yyvsp[-1].id);
					;
    break;}
case 62:
#line 504 "parse.y"
{
			yyval.sigtype = SIGNAL_LAST_METHOD;
					;
    break;}
case 63:
#line 510 "parse.y"
{
			if(strcmp(yyvsp[-1].id,"first")==0)
				yyval.sigtype = SIGNAL_FIRST_METHOD;
			else if(strcmp(yyvsp[-1].id,"last")==0)
				yyval.sigtype = SIGNAL_LAST_METHOD;
			else {
				yyerror(_("signal must be 'first' or 'last'"));
				g_free(yyvsp[-1].id);
				YYERROR;
			}
			g_free(yyvsp[-1].id);
					;
    break;}
case 64:
#line 522 "parse.y"
{
			if(strcmp(yyvsp[-2].id,"first")==0)
				yyval.sigtype = SIGNAL_FIRST_METHOD;
			else if(strcmp(yyvsp[-2].id,"last")==0)
				yyval.sigtype = SIGNAL_LAST_METHOD;
			else {
				yyerror(_("signal must be 'first' or 'last'"));
				g_free(yyvsp[-2].id);
				YYERROR;
			}
			g_free(yyvsp[-2].id);
					;
    break;}
case 65:
#line 534 "parse.y"
{
			yyval.sigtype = SIGNAL_LAST_METHOD;
					;
    break;}
case 66:
#line 537 "parse.y"
{
			/* the_scope was default thus public */
			the_scope = PUBLIC_SCOPE;
					;
    break;}
case 67:
#line 543 "parse.y"
{
			gtktypes = g_list_prepend(gtktypes,yyvsp[-3].id);
						;
    break;}
case 68:
#line 548 "parse.y"
{
			gtktypes = g_list_append(gtktypes,yyvsp[0].id);
						;
    break;}
case 69:
#line 551 "parse.y"
{ 
			gtktypes = g_list_append(gtktypes,yyvsp[0].id);
       						;
    break;}
case 70:
#line 556 "parse.y"
{ yyval.cbuf = yyvsp[0].cbuf; ;
    break;}
case 71:
#line 557 "parse.y"
{ yyval.cbuf = NULL; ;
    break;}
case 72:
#line 561 "parse.y"
{
			if(!has_self) {
				yyerror(_("signal without 'self' as "
					  "first parameter"));
				YYERROR;
			}
			push_function(the_scope, yyvsp[-7].sigtype,NULL,
				      yyvsp[-5].id, yyvsp[-1].id, yyvsp[0].cbuf,yyvsp[-9].line,
				      ccode_line, vararg, yyvsp[-8].list);
									;
    break;}
case 73:
#line 571 "parse.y"
{
			if(!has_self) {
				yyerror(_("signal without 'self' as "
					  "first parameter"));
				YYERROR;
			}
			push_function(the_scope, yyvsp[-7].sigtype, NULL,
				      yyvsp[-5].id, yyvsp[-1].id, yyvsp[0].cbuf, yyvsp[-9].line,
				      ccode_line, vararg, yyvsp[-8].list);
									;
    break;}
case 74:
#line 581 "parse.y"
{
			if(!has_self) {
				yyerror(_("virtual method without 'self' as "
					  "first parameter"));
				YYERROR;
			}
			push_function(the_scope, VIRTUAL_METHOD, NULL, yyvsp[-5].id,
				      yyvsp[-1].id, yyvsp[0].cbuf, yyvsp[-8].line,
				      ccode_line, vararg, NULL);
									;
    break;}
case 75:
#line 591 "parse.y"
{
			if(!has_self) {
				yyerror(_("virtual method without 'self' as "
					  "first parameter"));
				YYERROR;
			}
			push_function(the_scope, VIRTUAL_METHOD, NULL, yyvsp[-5].id,
				      yyvsp[-1].id, yyvsp[0].cbuf, yyvsp[-7].line,
				      ccode_line, vararg, NULL);
									;
    break;}
case 76:
#line 601 "parse.y"
{
			if(!has_self) {
				yyerror(_("virtual method without 'self' as "
					  "first parameter"));
				YYERROR;
			}
			push_function(PUBLIC_SCOPE, VIRTUAL_METHOD, NULL,
				      yyvsp[-5].id, yyvsp[-1].id, yyvsp[0].cbuf, yyvsp[-7].line,
				      ccode_line, vararg, NULL);
									;
    break;}
case 77:
#line 611 "parse.y"
{
			push_function(NO_SCOPE, OVERRIDE_METHOD, yyvsp[-8].id,
				      yyvsp[-5].id, yyvsp[-1].id, yyvsp[0].cbuf,
				      yyvsp[-10].line, ccode_line,
				      vararg, NULL);
									;
    break;}
case 78:
#line 617 "parse.y"
{
			push_function(the_scope, REGULAR_METHOD, NULL, yyvsp[-5].id,
				      yyvsp[-1].id, yyvsp[0].cbuf, yyvsp[-7].line, ccode_line,
				      vararg, NULL);
								;
    break;}
case 79:
#line 622 "parse.y"
{
			if(strcmp(yyvsp[-4].id,"init")==0) {
				push_init_arg(yyvsp[-2].id,FALSE);
				push_function(NO_SCOPE, INIT_METHOD, NULL,
					      yyvsp[-4].id, NULL, yyvsp[0].cbuf, yyvsp[-3].line,
					      ccode_line, FALSE, NULL);
			} else if(strcmp(yyvsp[-4].id,"class_init")==0) {
				push_init_arg(yyvsp[-2].id,TRUE);
				push_function(NO_SCOPE, CLASS_INIT_METHOD, NULL,
					      yyvsp[-4].id, NULL, yyvsp[0].cbuf, yyvsp[-3].line,
					      ccode_line, FALSE, NULL);
			} else {
				g_free(yyvsp[-4].id);
				g_free(yyvsp[-2].id);
				g_string_free(yyvsp[-2].cbuf,TRUE);
				yyerror(_("parse error"));
				YYERROR;
			}
						;
    break;}
case 80:
#line 643 "parse.y"
{ yyval.id = yyvsp[0].id; ;
    break;}
case 81:
#line 644 "parse.y"
{
			yyval.id = (yyvsp[0].cbuf)->str;
			g_string_free(yyvsp[0].cbuf,FALSE);
					;
    break;}
case 82:
#line 648 "parse.y"
{ yyval.id = NULL; ;
    break;}
case 83:
#line 651 "parse.y"
{ vararg = FALSE; has_self = FALSE; ;
    break;}
case 84:
#line 652 "parse.y"
{
			vararg = FALSE;
			has_self = TRUE;
			if(strcmp(yyvsp[0].id,"self")==0)
				push_self(yyvsp[0].id);
			else {
				g_free(yyvsp[0].id);
				yyerror(_("parse error"));
				YYERROR;
			}
       					;
    break;}
case 85:
#line 663 "parse.y"
{
			has_self = TRUE;
			if(strcmp(yyvsp[-2].id,"self")==0)
				push_self(yyvsp[-2].id);
			else {
				g_free(yyvsp[-2].id);
				yyerror(_("parse error"));
				YYERROR;
			}
					;
    break;}
case 86:
#line 673 "parse.y"
{ has_self = FALSE; ;
    break;}
case 87:
#line 676 "parse.y"
{ vararg = TRUE; ;
    break;}
case 88:
#line 677 "parse.y"
{ vararg = FALSE; ;
    break;}
case 89:
#line 680 "parse.y"
{ ; ;
    break;}
case 90:
#line 681 "parse.y"
{ ; ;
    break;}
case 91:
#line 684 "parse.y"
{
			push_funcarg(yyvsp[0].id,NULL);
								;
    break;}
case 92:
#line 687 "parse.y"
{
			push_funcarg(yyvsp[-1].id,yyvsp[0].id);
								;
    break;}
case 93:
#line 690 "parse.y"
{
			if(strcmp(yyvsp[-2].id,"check")!=0) {
				yyerror(_("parse error"));
				YYERROR;
			}
			g_free(yyvsp[-2].id);
			push_funcarg(yyvsp[-4].id,NULL);
								;
    break;}
case 94:
#line 698 "parse.y"
{
			if(strcmp(yyvsp[-2].id,"check")!=0) {
				yyerror(_("parse error"));
				YYERROR;
			}
			g_free(yyvsp[-2].id);
			push_funcarg(yyvsp[-5].id,yyvsp[-4].id);
								;
    break;}
case 95:
#line 708 "parse.y"
{ ; ;
    break;}
case 96:
#line 709 "parse.y"
{ ; ;
    break;}
case 97:
#line 712 "parse.y"
{
			if(strcmp(yyvsp[0].id,"type")==0) {
				Node *node = new_check(TYPE_CHECK,NULL);
				checks = g_list_append(checks,node);
			} else if(strcmp(yyvsp[0].id,"null")==0) {
				Node *node = new_check(NULL_CHECK,NULL);
				checks = g_list_append(checks,node);
			} else {
				yyerror(_("parse error"));
				YYERROR;
			}
			g_free(yyvsp[0].id);
					;
    break;}
case 98:
#line 725 "parse.y"
{
			Node *node = new_check(GT_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 99:
#line 729 "parse.y"
{
			Node *node = new_check(LT_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 100:
#line 733 "parse.y"
{
			Node *node = new_check(GE_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 101:
#line 737 "parse.y"
{
			Node *node = new_check(LE_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 102:
#line 741 "parse.y"
{
			Node *node = new_check(EQ_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 103:
#line 745 "parse.y"
{
			Node *node = new_check(NE_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 104:
#line 751 "parse.y"
{ yyval.id = yyvsp[0].id; ;
    break;}
case 105:
#line 752 "parse.y"
{
			yyval.id = g_strconcat("-",yyvsp[0].id,NULL);
			g_free(yyvsp[0].id);
					;
    break;}
case 106:
#line 756 "parse.y"
{ yyval.id = yyvsp[0].id; ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 759 "parse.y"

